import _inheritsLoose from "@babel/runtime/helpers/esm/inheritsLoose";
import _assertThisInitialized from "@babel/runtime/helpers/esm/assertThisInitialized";

/* global document */

/* eslint react/no-find-dom-node: 0 */
import * as React from 'react';
import PropTypes from 'prop-types';
import { findDOMNode } from 'react-dom';
import rafThrottle from 'raf-throttle';

var ClickOutside =
/*#__PURE__*/
function (_React$Component) {
  _inheritsLoose(ClickOutside, _React$Component);

  function ClickOutside() {
    var _this;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _React$Component.call.apply(_React$Component, [this].concat(args)) || this;
    _this.handleClickOutside = rafThrottle(function (e) {
      var onClick = _this.props.onClick;
      var node = findDOMNode(_assertThisInitialized(_assertThisInitialized(_this)));
      if (node && node.contains(e.target)) return; // Node: Omit clicking itself.

      onClick(e);
    });
    return _this;
  }

  var _proto = ClickOutside.prototype;

  _proto.componentDidMount = function componentDidMount() {
    document.addEventListener('click', this.handleClickOutside, true);
    document.addEventListener('touchend', this.handleClickOutside, true);
  };

  _proto.componentWillUnmount = function componentWillUnmount() {
    document.removeEventListener('click', this.handleClickOutside, true);
    document.removeEventListener('touchend', this.handleClickOutside, true);

    if (this.handleClickOutside && this.handleClickOutside.cancel) {
      this.handleClickOutside.cancel();
    }
  };

  _proto.render = function render() {
    var children = this.props.children;
    return children;
  };

  return ClickOutside;
}(React.Component);

process.env.NODE_ENV !== "production" ? ClickOutside.propTypes = {
  children: PropTypes.node.isRequired,
  onClick: PropTypes.func.isRequired
} : void 0;
export default ClickOutside;