import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
import _inheritsLoose from "@babel/runtime/helpers/esm/inheritsLoose";
import * as React from 'react';
import * as R from 'ramda';
import PropTypes from 'prop-types';
import Transition from '../Transition';
import Portal from '../Portal';
import DomAlign from '../DomAlign';
import ClickOutside from '../ClickOutside';
import emptyFunction from '../utils/emptyFunction';

var Overlay =
/*#__PURE__*/
function (_React$Component) {
  _inheritsLoose(Overlay, _React$Component);

  function Overlay() {
    var _this;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _React$Component.call.apply(_React$Component, [this].concat(args)) || this;

    _this.onOutsideClick = function (e) {
      var _this$props = _this.props,
          target = _this$props.target,
          onOutsideClick = _this$props.onOutsideClick;
      if (target.current && target.current.contains(e.target)) return; // Note: Omit clicking target.

      if (onOutsideClick) {
        onOutsideClick(e);
      }
    };

    return _this;
  }

  var _proto = Overlay.prototype;

  _proto.render = function render() {
    var _this$props2 = this.props,
        show = _this$props2.show,
        alignConfig = _this$props2.alignConfig,
        target = _this$props2.target,
        transitionConfig = _this$props2.transitionConfig,
        children = _this$props2.children,
        resize = _this$props2.resize,
        style = _this$props2.style,
        otherProps = _objectWithoutPropertiesLoose(_this$props2, ["show", "alignConfig", "target", "transitionConfig", "children", "resize", "style"]);

    var onOutsideClick = this.onOutsideClick;
    return show && React.createElement(Portal, null, React.createElement(ClickOutside, {
      onClick: onOutsideClick
    }, React.createElement(DomAlign, {
      config: _extends({}, alignConfig),
      target: target,
      resize: resize
    }, React.createElement("div", _extends({
      style: _extends({
        position: 'absolute'
      }, style)
    }, R.omit(['onOutsideClick'])(otherProps)), React.createElement(Transition, _extends({}, transitionConfig, {
      component: false
    }), children)))));
  };

  return Overlay;
}(React.Component);

Overlay.defaultProps = {
  show: false,
  onOutsideClick: emptyFunction,
  alignConfig: {
    points: ['tr', 'br'],
    // bottom-right
    offset: [0, 0]
  },
  transitionConfig: {
    // From
    style: {
      opacity: 0
    },
    // To
    animation: {
      opacity: 1
    }
  },
  resize: false
};
process.env.NODE_ENV !== "production" ? Overlay.propTypes = {
  show: PropTypes.bool,
  children: PropTypes.node.isRequired,
  onOutsideClick: PropTypes.func,
  // Note: for root close
  target: PropTypes.object,
  // eslint-disable-line
  alignConfig: PropTypes.shape({
    points: PropTypes.array,
    offset: PropTypes.array
  }),
  // docs: https://github.com/yiminghe/dom-align#alignconfig-object-details
  transitionConfig: PropTypes.shape({
    style: PropTypes.object,
    animation: PropTypes.object
  }),
  // docs: https://github.com/react-component/tween-one
  resize: PropTypes.bool
} : void 0;
export default Overlay;