"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.default = void 0;

var _inheritsLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/inheritsLoose"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var React = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _reactDom = require("react-dom");

var _rafThrottle = _interopRequireDefault(require("raf-throttle"));

/* global document */

/* eslint react/no-find-dom-node: 0 */
var ClickOutside =
/*#__PURE__*/
function (_React$Component) {
  (0, _inheritsLoose2.default)(ClickOutside, _React$Component);

  function ClickOutside() {
    var _this;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _React$Component.call.apply(_React$Component, [this].concat(args)) || this;
    _this.handleClickOutside = (0, _rafThrottle.default)(function (e) {
      var onClick = _this.props.onClick;
      var node = (0, _reactDom.findDOMNode)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)));
      if (node && node.contains(e.target)) return; // Node: Omit clicking itself.

      onClick(e);
    });
    return _this;
  }

  var _proto = ClickOutside.prototype;

  _proto.componentDidMount = function componentDidMount() {
    document.addEventListener('click', this.handleClickOutside, true);
    document.addEventListener('touchend', this.handleClickOutside, true);
  };

  _proto.componentWillUnmount = function componentWillUnmount() {
    document.removeEventListener('click', this.handleClickOutside, true);
    document.removeEventListener('touchend', this.handleClickOutside, true);

    if (this.handleClickOutside && this.handleClickOutside.cancel) {
      this.handleClickOutside.cancel();
    }
  };

  _proto.render = function render() {
    var children = this.props.children;
    return children;
  };

  return ClickOutside;
}(React.Component);

process.env.NODE_ENV !== "production" ? ClickOutside.propTypes = {
  children: _propTypes.default.node.isRequired,
  onClick: _propTypes.default.func.isRequired
} : void 0;
var _default = ClickOutside;
exports.default = _default;
module.exports = exports.default;