"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var React = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _Portal = _interopRequireDefault(require("../Portal"));

var _Transition = _interopRequireDefault(require("../Transition"));

var _ClickOutside = _interopRequireDefault(require("../ClickOutside"));

var _emptyFunction = _interopRequireDefault(require("../utils/emptyFunction"));

var _Components = require("./Components");

var Dialog = function Dialog(_ref) {
  var show = _ref.show,
      children = _ref.children,
      onOutsideClick = _ref.onOutsideClick,
      backdropTransition = _ref.backdropTransition,
      containerTransition = _ref.containerTransition;
  return show && React.createElement(React.Fragment, null, React.createElement(_Portal.default, null, React.createElement(_Transition.default, (0, _extends2.default)({
    component: _Components.BackdropContainer
  }, backdropTransition))), React.createElement(_Portal.default, null, React.createElement(_Components.Container, null, React.createElement(_ClickOutside.default, {
    onClick: onOutsideClick
  }, React.createElement(_Transition.default, (0, _extends2.default)({
    component: false
  }, containerTransition), children)))));
};

process.env.NODE_ENV !== "production" ? Dialog.propTypes = {
  show: _propTypes.default.bool,
  children: _propTypes.default.node.isRequired,
  onOutsideClick: _propTypes.default.func,
  backdropTransition: _propTypes.default.shape({
    style: _propTypes.default.object,
    animation: _propTypes.default.object
  }),
  containerTransition: _propTypes.default.shape({
    style: _propTypes.default.object,
    animation: _propTypes.default.object
  })
} : void 0;
Dialog.defaultProps = {
  show: false,
  onOutsideClick: _emptyFunction.default,
  backdropTransition: {
    style: {
      opacity: 0.3
    },
    animation: {
      ease: 'easeOutCubic',
      duration: 200,
      delay: 0,
      opacity: 1
    }
  },
  containerTransition: {
    style: {
      transform: 'translateY(-20px)'
    },
    animation: {
      ease: 'easeOutQuart',
      duration: 200,
      delay: 0,
      translateY: 0
    }
  }
};
var _default = Dialog;
exports.default = _default;
module.exports = exports.default;