"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.default = void 0;

var _inheritsLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/inheritsLoose"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var React = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _domAlign = _interopRequireDefault(require("dom-align"));

var _rafThrottle = _interopRequireDefault(require("raf-throttle"));

/* global window */
var DomAlign =
/*#__PURE__*/
function (_React$Component) {
  (0, _inheritsLoose2.default)(DomAlign, _React$Component);

  function DomAlign(props) {
    var _this;

    _this = _React$Component.call(this, props) || this;
    _this.timeoutId = void 0;
    _this.source = void 0;
    _this.align = void 0;
    _this.source = React.createRef();
    _this.align = (0, _rafThrottle.default)(function () {
      var _this$props = _this.props,
          target = _this$props.target,
          config = _this$props.config;

      var _assertThisInitialize = (0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)),
          source = _assertThisInitialize.source;

      if (target && target.current && source && source.current) {
        // Note: Wait for two react instance ready.
        (0, _domAlign.default)(source.current, target.current, config);
      }
    });
    return _this;
  }

  var _proto = DomAlign.prototype;

  _proto.componentDidMount = function componentDidMount() {
    var resize = this.props.resize;
    this.align();

    if (resize) {
      window.addEventListener('resize', this.align);
      window.addEventListener('scroll', this.align);
      window.addEventListener('wheel', this.align);
    }
  };

  _proto.componentDidUpdate = function componentDidUpdate() {
    var _this2 = this;

    // TODO: make it async. there is a problem of overlay in dialog case.
    this.timeoutId = setTimeout(function () {
      return _this2.align();
    });
  };

  _proto.componentWillUnmount = function componentWillUnmount() {
    var resize = this.props.resize;

    if (resize) {
      window.removeEventListener('resize', this.align);
      window.removeEventListener('scroll', this.align);
      window.removeEventListener('wheel', this.align);
    }

    if (this.align && this.align.cancel) this.align.cancel();
    if (this.timeoutId) clearTimeout(this.timeoutId);
  };

  _proto.render = function render() {
    var children = this.props.children;
    var source = this.source;
    return React.cloneElement(React.Children.only(children), {
      ref: source
    });
  };

  return DomAlign;
}(React.Component);

DomAlign.defaultProps = {
  target: undefined,
  resize: false
};
process.env.NODE_ENV !== "production" ? DomAlign.propTypes = {
  children: _propTypes.default.element.isRequired,
  config: _propTypes.default.shape({
    points: _propTypes.default.array,
    offset: _propTypes.default.array
  }),
  target: _propTypes.default.object,
  // eslint-disable-line
  resize: _propTypes.default.bool
} : void 0;
var _default = DomAlign;
exports.default = _default;
module.exports = exports.default;