"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));

var _inheritsLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/inheritsLoose"));

var React = _interopRequireWildcard(require("react"));

var R = _interopRequireWildcard(require("ramda"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _Transition = _interopRequireDefault(require("../Transition"));

var _Portal = _interopRequireDefault(require("../Portal"));

var _DomAlign = _interopRequireDefault(require("../DomAlign"));

var _ClickOutside = _interopRequireDefault(require("../ClickOutside"));

var _emptyFunction = _interopRequireDefault(require("../utils/emptyFunction"));

var Overlay =
/*#__PURE__*/
function (_React$Component) {
  (0, _inheritsLoose2.default)(Overlay, _React$Component);

  function Overlay() {
    var _this;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _React$Component.call.apply(_React$Component, [this].concat(args)) || this;

    _this.onOutsideClick = function (e) {
      var _this$props = _this.props,
          target = _this$props.target,
          onOutsideClick = _this$props.onOutsideClick;
      if (target.current && target.current.contains(e.target)) return; // Note: Omit clicking target.

      if (onOutsideClick) {
        onOutsideClick(e);
      }
    };

    return _this;
  }

  var _proto = Overlay.prototype;

  _proto.render = function render() {
    var _this$props2 = this.props,
        show = _this$props2.show,
        alignConfig = _this$props2.alignConfig,
        target = _this$props2.target,
        transitionConfig = _this$props2.transitionConfig,
        children = _this$props2.children,
        resize = _this$props2.resize,
        style = _this$props2.style,
        otherProps = (0, _objectWithoutPropertiesLoose2.default)(_this$props2, ["show", "alignConfig", "target", "transitionConfig", "children", "resize", "style"]);
    var onOutsideClick = this.onOutsideClick;
    return show && React.createElement(_Portal.default, null, React.createElement(_ClickOutside.default, {
      onClick: onOutsideClick
    }, React.createElement(_DomAlign.default, {
      config: (0, _extends2.default)({}, alignConfig),
      target: target,
      resize: resize
    }, React.createElement("div", (0, _extends2.default)({
      style: (0, _extends2.default)({
        position: 'absolute'
      }, style)
    }, R.omit(['onOutsideClick'])(otherProps)), React.createElement(_Transition.default, (0, _extends2.default)({}, transitionConfig, {
      component: false
    }), children)))));
  };

  return Overlay;
}(React.Component);

Overlay.defaultProps = {
  show: false,
  onOutsideClick: _emptyFunction.default,
  alignConfig: {
    points: ['tr', 'br'],
    // bottom-right
    offset: [0, 0]
  },
  transitionConfig: {
    // From
    style: {
      opacity: 0
    },
    // To
    animation: {
      opacity: 1
    }
  },
  resize: false
};
process.env.NODE_ENV !== "production" ? Overlay.propTypes = {
  show: _propTypes.default.bool,
  children: _propTypes.default.node.isRequired,
  onOutsideClick: _propTypes.default.func,
  // Note: for root close
  target: _propTypes.default.object,
  // eslint-disable-line
  alignConfig: _propTypes.default.shape({
    points: _propTypes.default.array,
    offset: _propTypes.default.array
  }),
  // docs: https://github.com/yiminghe/dom-align#alignconfig-object-details
  transitionConfig: _propTypes.default.shape({
    style: _propTypes.default.object,
    animation: _propTypes.default.object
  }),
  // docs: https://github.com/react-component/tween-one
  resize: _propTypes.default.bool
} : void 0;
var _default = Overlay;
exports.default = _default;
module.exports = exports.default;